/* AccessControlLists.c generated by valac 0.56.17, the Vala compiler
 * generated from AccessControlLists.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2019 Adam Bieńkowski (https://github.com/elementary/switchboard-plug-parental-controls)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 *
 * Authored by: Adam Bieńkowski <donadigos159@gmail.com>
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <gio/gdesktopappinfo.h>
#include <gobject/gvaluecollector.h>

#define PC_ACCESS_CONTROL_LISTS_DEFAULT_PERMISSIONS "r-x"
#define PC_ACCESS_CONTROL_LISTS_NO_EXEC_PERMISSIONS "---"
#define PC_CONSTANTS_CLIENT_PATH "/usr/libexec/pantheon-parental-controls-client"
#define PC_CONSTANTS_PARENTAL_CONTROLS_ACTION_ID "io.elementary.settings.screentime-limits.administration"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define PC_TYPE_ACCESS_CONTROL_LISTS (pc_access_control_lists_get_type ())
#define PC_ACCESS_CONTROL_LISTS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PC_TYPE_ACCESS_CONTROL_LISTS, PCAccessControlLists))
#define PC_ACCESS_CONTROL_LISTS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PC_TYPE_ACCESS_CONTROL_LISTS, PCAccessControlListsClass))
#define PC_IS_ACCESS_CONTROL_LISTS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PC_TYPE_ACCESS_CONTROL_LISTS))
#define PC_IS_ACCESS_CONTROL_LISTS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PC_TYPE_ACCESS_CONTROL_LISTS))
#define PC_ACCESS_CONTROL_LISTS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PC_TYPE_ACCESS_CONTROL_LISTS, PCAccessControlListsClass))

typedef struct _PCAccessControlLists PCAccessControlLists;
typedef struct _PCAccessControlListsClass PCAccessControlListsClass;
typedef struct _PCAccessControlListsPrivate PCAccessControlListsPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_key_file_unref0(var) ((var == NULL) ? NULL : (var = (g_key_file_unref (var), NULL)))
typedef struct _PCParamSpecAccessControlLists PCParamSpecAccessControlLists;

struct _PCAccessControlLists {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PCAccessControlListsPrivate * priv;
};

struct _PCAccessControlListsClass {
	GTypeClass parent_class;
	void (*finalize) (PCAccessControlLists *self);
};

struct _PCParamSpecAccessControlLists {
	GParamSpec parent_instance;
};

static gpointer pc_access_control_lists_parent_class = NULL;

VALA_EXTERN gpointer pc_access_control_lists_ref (gpointer instance);
VALA_EXTERN void pc_access_control_lists_unref (gpointer instance);
VALA_EXTERN GParamSpec* pc_param_spec_access_control_lists (const gchar* name,
                                                const gchar* nick,
                                                const gchar* blurb,
                                                GType object_type,
                                                GParamFlags flags);
VALA_EXTERN void pc_value_set_access_control_lists (GValue* value,
                                        gpointer v_object);
VALA_EXTERN void pc_value_take_access_control_lists (GValue* value,
                                         gpointer v_object);
VALA_EXTERN gpointer pc_value_get_access_control_lists (const GValue* value);
VALA_EXTERN GType pc_access_control_lists_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PCAccessControlLists, pc_access_control_lists_unref)
static GAppInfo* pc_access_control_lists_get_match (const gchar* target,
                                             GList* infos);
static GFile* pc_access_control_lists_create_desktop_files_dir (const gchar* username);
static gchar* pc_access_control_lists_process_desktop_entry (const gchar* path,
                                                      const gchar* target,
                                                      const gchar* username,
                                                      gboolean admin);
VALA_EXTERN gchar* pc_utils_info_to_exec_path (GAppInfo* info,
                                   gchar*** args,
                                   gint* args_length1);
VALA_EXTERN gboolean pc_access_control_lists_get_supported (void);
VALA_EXTERN void pc_access_control_lists_setfacl (const gchar* username,
                                      const gchar* target,
                                      const gchar* permissions_str);
static void pc_access_control_lists_apply_permissions (const gchar* username,
                                                gchar** targets,
                                                gint targets_length1,
                                                const gchar* permissions_str,
                                                gboolean admin);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
VALA_EXTERN void pc_access_control_lists_apply_targets (const gchar* username,
                                            gchar** old_targets,
                                            gint old_targets_length1,
                                            gchar** targets,
                                            gint targets_length1,
                                            gboolean old_admin,
                                            gboolean admin);
VALA_EXTERN PCAccessControlLists* pc_access_control_lists_new (void);
VALA_EXTERN PCAccessControlLists* pc_access_control_lists_construct (GType object_type);
static void pc_access_control_lists_finalize (PCAccessControlLists * obj);
static GType pc_access_control_lists_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static gpointer
_g_object_ref0 (gpointer self)
{
#line 29 "../src/daemon/AccessControlLists.vala"
	return self ? g_object_ref (self) : NULL;
#line 148 "AccessControlLists.c"
}

static GAppInfo*
pc_access_control_lists_get_match (const gchar* target,
                                   GList* infos)
{
	gchar* basename = NULL;
	gchar* _tmp0_;
	GAppInfo* result;
#line 27 "../src/daemon/AccessControlLists.vala"
	g_return_val_if_fail (target != NULL, NULL);
#line 28 "../src/daemon/AccessControlLists.vala"
	_tmp0_ = g_path_get_basename (target);
#line 28 "../src/daemon/AccessControlLists.vala"
	basename = _tmp0_;
#line 164 "AccessControlLists.c"
	{
		GList* info_collection = NULL;
		GList* info_it = NULL;
#line 29 "../src/daemon/AccessControlLists.vala"
		info_collection = infos;
#line 29 "../src/daemon/AccessControlLists.vala"
		for (info_it = info_collection; info_it != NULL; info_it = info_it->next) {
#line 172 "AccessControlLists.c"
			GAppInfo* _tmp1_;
			GAppInfo* info = NULL;
#line 29 "../src/daemon/AccessControlLists.vala"
			_tmp1_ = _g_object_ref0 ((GAppInfo*) info_it->data);
#line 29 "../src/daemon/AccessControlLists.vala"
			info = _tmp1_;
#line 179 "AccessControlLists.c"
			{
				gboolean _tmp2_ = FALSE;
				GAppInfo* _tmp3_;
#line 30 "../src/daemon/AccessControlLists.vala"
				_tmp3_ = info;
#line 30 "../src/daemon/AccessControlLists.vala"
				if (g_app_info_should_show (_tmp3_)) {
#line 187 "AccessControlLists.c"
					GAppInfo* _tmp4_;
					const gchar* _tmp5_;
					const gchar* _tmp6_;
#line 30 "../src/daemon/AccessControlLists.vala"
					_tmp4_ = info;
#line 30 "../src/daemon/AccessControlLists.vala"
					_tmp5_ = g_app_info_get_executable (_tmp4_);
#line 30 "../src/daemon/AccessControlLists.vala"
					_tmp6_ = basename;
#line 30 "../src/daemon/AccessControlLists.vala"
					_tmp2_ = g_strcmp0 (_tmp5_, _tmp6_) == 0;
#line 199 "AccessControlLists.c"
				} else {
#line 30 "../src/daemon/AccessControlLists.vala"
					_tmp2_ = FALSE;
#line 203 "AccessControlLists.c"
				}
#line 30 "../src/daemon/AccessControlLists.vala"
				if (_tmp2_) {
#line 31 "../src/daemon/AccessControlLists.vala"
					result = info;
#line 31 "../src/daemon/AccessControlLists.vala"
					_g_free0 (basename);
#line 31 "../src/daemon/AccessControlLists.vala"
					return result;
#line 213 "AccessControlLists.c"
				}
#line 29 "../src/daemon/AccessControlLists.vala"
				_g_object_unref0 (info);
#line 217 "AccessControlLists.c"
			}
		}
	}
#line 35 "../src/daemon/AccessControlLists.vala"
	result = NULL;
#line 35 "../src/daemon/AccessControlLists.vala"
	_g_free0 (basename);
#line 35 "../src/daemon/AccessControlLists.vala"
	return result;
#line 227 "AccessControlLists.c"
}

static GFile*
pc_access_control_lists_create_desktop_files_dir (const gchar* username)
{
	gchar* local_appdir = NULL;
	gchar* _tmp0_;
	GFile* appdir_file = NULL;
	const gchar* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	GError* _inner_error0_ = NULL;
	GFile* result;
#line 38 "../src/daemon/AccessControlLists.vala"
	g_return_val_if_fail (username != NULL, NULL);
#line 39 "../src/daemon/AccessControlLists.vala"
	_tmp0_ = g_build_filename (G_DIR_SEPARATOR_S, "home", username, ".local", "share", "applications", NULL);
#line 39 "../src/daemon/AccessControlLists.vala"
	local_appdir = _tmp0_;
#line 47 "../src/daemon/AccessControlLists.vala"
	_tmp1_ = local_appdir;
#line 47 "../src/daemon/AccessControlLists.vala"
	_tmp2_ = g_file_new_for_path (_tmp1_);
#line 47 "../src/daemon/AccessControlLists.vala"
	appdir_file = _tmp2_;
#line 48 "../src/daemon/AccessControlLists.vala"
	_tmp3_ = appdir_file;
#line 48 "../src/daemon/AccessControlLists.vala"
	if (!g_file_query_exists (_tmp3_, NULL)) {
#line 257 "AccessControlLists.c"
		{
			gboolean _tmp4_ = FALSE;
			GFile* _tmp5_;
#line 50 "../src/daemon/AccessControlLists.vala"
			_tmp5_ = appdir_file;
#line 50 "../src/daemon/AccessControlLists.vala"
			_tmp4_ = g_file_make_directory_with_parents (_tmp5_, NULL, &_inner_error0_);
#line 50 "../src/daemon/AccessControlLists.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 267 "AccessControlLists.c"
				goto __catch0_g_error;
			}
#line 50 "../src/daemon/AccessControlLists.vala"
			if (!_tmp4_) {
#line 51 "../src/daemon/AccessControlLists.vala"
				result = NULL;
#line 51 "../src/daemon/AccessControlLists.vala"
				_g_object_unref0 (appdir_file);
#line 51 "../src/daemon/AccessControlLists.vala"
				_g_free0 (local_appdir);
#line 51 "../src/daemon/AccessControlLists.vala"
				return result;
#line 280 "AccessControlLists.c"
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp6_;
			const gchar* _tmp7_;
#line 49 "../src/daemon/AccessControlLists.vala"
			e = _inner_error0_;
#line 49 "../src/daemon/AccessControlLists.vala"
			_inner_error0_ = NULL;
#line 54 "../src/daemon/AccessControlLists.vala"
			_tmp6_ = e;
#line 54 "../src/daemon/AccessControlLists.vala"
			_tmp7_ = _tmp6_->message;
#line 54 "../src/daemon/AccessControlLists.vala"
			g_warning ("AccessControlLists.vala:54: %s", _tmp7_);
#line 55 "../src/daemon/AccessControlLists.vala"
			result = NULL;
#line 55 "../src/daemon/AccessControlLists.vala"
			_g_error_free0 (e);
#line 55 "../src/daemon/AccessControlLists.vala"
			_g_object_unref0 (appdir_file);
#line 55 "../src/daemon/AccessControlLists.vala"
			_g_free0 (local_appdir);
#line 55 "../src/daemon/AccessControlLists.vala"
			return result;
#line 309 "AccessControlLists.c"
		}
		__finally0:
#line 49 "../src/daemon/AccessControlLists.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 49 "../src/daemon/AccessControlLists.vala"
			_g_object_unref0 (appdir_file);
#line 49 "../src/daemon/AccessControlLists.vala"
			_g_free0 (local_appdir);
#line 49 "../src/daemon/AccessControlLists.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 49 "../src/daemon/AccessControlLists.vala"
			g_clear_error (&_inner_error0_);
#line 49 "../src/daemon/AccessControlLists.vala"
			return NULL;
#line 324 "AccessControlLists.c"
		}
	}
#line 59 "../src/daemon/AccessControlLists.vala"
	result = appdir_file;
#line 59 "../src/daemon/AccessControlLists.vala"
	_g_free0 (local_appdir);
#line 59 "../src/daemon/AccessControlLists.vala"
	return result;
#line 333 "AccessControlLists.c"
}

static gchar*
_vala_g_strjoinv (const gchar* separator,
                  gchar** str_array,
                  gint str_array_length1)
{
	gboolean _tmp0_ = FALSE;
	gchar* result;
#line 1251 "glib-2.0.vapi"
	if (separator == NULL) {
#line 1252 "glib-2.0.vapi"
		separator = "";
#line 347 "AccessControlLists.c"
	}
#line 1254 "glib-2.0.vapi"
	if (str_array != NULL) {
#line 351 "AccessControlLists.c"
		gboolean _tmp1_ = FALSE;
#line 1254 "glib-2.0.vapi"
		if (str_array_length1 > 0) {
#line 1254 "glib-2.0.vapi"
			_tmp1_ = TRUE;
#line 357 "AccessControlLists.c"
		} else {
			gboolean _tmp2_ = FALSE;
#line 1254 "glib-2.0.vapi"
			if (str_array_length1 == -1) {
#line 362 "AccessControlLists.c"
				const gchar* _tmp3_;
#line 1254 "glib-2.0.vapi"
				_tmp3_ = str_array[0];
#line 1254 "glib-2.0.vapi"
				_tmp2_ = _tmp3_ != NULL;
#line 368 "AccessControlLists.c"
			} else {
#line 1254 "glib-2.0.vapi"
				_tmp2_ = FALSE;
#line 372 "AccessControlLists.c"
			}
#line 1254 "glib-2.0.vapi"
			_tmp1_ = _tmp2_;
#line 376 "AccessControlLists.c"
		}
#line 1254 "glib-2.0.vapi"
		_tmp0_ = _tmp1_;
#line 380 "AccessControlLists.c"
	} else {
#line 1254 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 384 "AccessControlLists.c"
	}
#line 1254 "glib-2.0.vapi"
	if (_tmp0_) {
#line 388 "AccessControlLists.c"
		gint i = 0;
		gsize len = 0UL;
		gint _tmp16_;
		gint _tmp17_;
		const gchar* res = NULL;
		void* _tmp18_;
		const gchar* _tmp19_ = NULL;
		const gchar* _tmp20_;
		void* ptr = NULL;
		const gchar* _tmp22_;
		void* _tmp23_;
		const gchar* _tmp33_;
#line 1256 "glib-2.0.vapi"
		len = (gsize) 1;
#line 403 "AccessControlLists.c"
		{
			gboolean _tmp4_ = FALSE;
#line 1257 "glib-2.0.vapi"
			i = 0;
#line 1257 "glib-2.0.vapi"
			_tmp4_ = TRUE;
#line 1257 "glib-2.0.vapi"
			while (TRUE) {
#line 412 "AccessControlLists.c"
				gboolean _tmp6_ = FALSE;
				gboolean _tmp7_ = FALSE;
				gint _tmp10_ = 0;
				const gchar* _tmp11_;
#line 1257 "glib-2.0.vapi"
				if (!_tmp4_) {
#line 419 "AccessControlLists.c"
					gint _tmp5_;
#line 1257 "glib-2.0.vapi"
					_tmp5_ = i;
#line 1257 "glib-2.0.vapi"
					i = _tmp5_ + 1;
#line 425 "AccessControlLists.c"
				}
#line 1257 "glib-2.0.vapi"
				_tmp4_ = FALSE;
#line 1257 "glib-2.0.vapi"
				if (str_array_length1 != -1) {
#line 1257 "glib-2.0.vapi"
					_tmp7_ = i < str_array_length1;
#line 433 "AccessControlLists.c"
				} else {
#line 1257 "glib-2.0.vapi"
					_tmp7_ = FALSE;
#line 437 "AccessControlLists.c"
				}
#line 1257 "glib-2.0.vapi"
				if (_tmp7_) {
#line 1257 "glib-2.0.vapi"
					_tmp6_ = TRUE;
#line 443 "AccessControlLists.c"
				} else {
					gboolean _tmp8_ = FALSE;
#line 1257 "glib-2.0.vapi"
					if (str_array_length1 == -1) {
#line 448 "AccessControlLists.c"
						const gchar* _tmp9_;
#line 1257 "glib-2.0.vapi"
						_tmp9_ = str_array[i];
#line 1257 "glib-2.0.vapi"
						_tmp8_ = _tmp9_ != NULL;
#line 454 "AccessControlLists.c"
					} else {
#line 1257 "glib-2.0.vapi"
						_tmp8_ = FALSE;
#line 458 "AccessControlLists.c"
					}
#line 1257 "glib-2.0.vapi"
					_tmp6_ = _tmp8_;
#line 462 "AccessControlLists.c"
				}
#line 1257 "glib-2.0.vapi"
				if (!_tmp6_) {
#line 1257 "glib-2.0.vapi"
					break;
#line 468 "AccessControlLists.c"
				}
#line 1258 "glib-2.0.vapi"
				_tmp11_ = str_array[i];
#line 1258 "glib-2.0.vapi"
				if (_tmp11_ != NULL) {
#line 474 "AccessControlLists.c"
					const gchar* _tmp12_;
					gint _tmp13_;
					gint _tmp14_;
#line 1258 "glib-2.0.vapi"
					_tmp12_ = str_array[i];
#line 1258 "glib-2.0.vapi"
					_tmp13_ = strlen ((const gchar*) _tmp12_);
#line 1258 "glib-2.0.vapi"
					_tmp14_ = _tmp13_;
#line 1258 "glib-2.0.vapi"
					_tmp10_ = _tmp14_;
#line 486 "AccessControlLists.c"
				} else {
#line 1258 "glib-2.0.vapi"
					_tmp10_ = 0;
#line 490 "AccessControlLists.c"
				}
#line 1258 "glib-2.0.vapi"
				len += (gsize) _tmp10_;
#line 494 "AccessControlLists.c"
			}
		}
#line 1260 "glib-2.0.vapi"
		if (i == 0) {
#line 499 "AccessControlLists.c"
			gchar* _tmp15_;
#line 1261 "glib-2.0.vapi"
			_tmp15_ = g_strdup ("");
#line 1261 "glib-2.0.vapi"
			result = _tmp15_;
#line 1261 "glib-2.0.vapi"
			return result;
#line 507 "AccessControlLists.c"
		}
#line 1263 "glib-2.0.vapi"
		str_array_length1 = i;
#line 1264 "glib-2.0.vapi"
		_tmp16_ = strlen ((const gchar*) separator);
#line 1264 "glib-2.0.vapi"
		_tmp17_ = _tmp16_;
#line 1264 "glib-2.0.vapi"
		len += (gsize) (_tmp17_ * (i - 1));
#line 1266 "glib-2.0.vapi"
		_tmp18_ = g_malloc (len);
#line 1266 "glib-2.0.vapi"
		res = _tmp18_;
#line 1267 "glib-2.0.vapi"
		_tmp20_ = str_array[0];
#line 1267 "glib-2.0.vapi"
		if (_tmp20_ != NULL) {
#line 525 "AccessControlLists.c"
			const gchar* _tmp21_;
#line 1267 "glib-2.0.vapi"
			_tmp21_ = str_array[0];
#line 1267 "glib-2.0.vapi"
			_tmp19_ = (const gchar*) _tmp21_;
#line 531 "AccessControlLists.c"
		} else {
#line 1267 "glib-2.0.vapi"
			_tmp19_ = "";
#line 535 "AccessControlLists.c"
		}
#line 1267 "glib-2.0.vapi"
		_tmp22_ = res;
#line 1267 "glib-2.0.vapi"
		_tmp23_ = g_stpcpy ((void*) _tmp22_, _tmp19_);
#line 1267 "glib-2.0.vapi"
		ptr = _tmp23_;
#line 543 "AccessControlLists.c"
		{
			gboolean _tmp24_ = FALSE;
#line 1268 "glib-2.0.vapi"
			i = 1;
#line 1268 "glib-2.0.vapi"
			_tmp24_ = TRUE;
#line 1268 "glib-2.0.vapi"
			while (TRUE) {
#line 552 "AccessControlLists.c"
				void* _tmp26_;
				void* _tmp27_;
				const gchar* _tmp28_ = NULL;
				const gchar* _tmp29_;
				void* _tmp31_;
				void* _tmp32_;
#line 1268 "glib-2.0.vapi"
				if (!_tmp24_) {
#line 561 "AccessControlLists.c"
					gint _tmp25_;
#line 1268 "glib-2.0.vapi"
					_tmp25_ = i;
#line 1268 "glib-2.0.vapi"
					i = _tmp25_ + 1;
#line 567 "AccessControlLists.c"
				}
#line 1268 "glib-2.0.vapi"
				_tmp24_ = FALSE;
#line 1268 "glib-2.0.vapi"
				if (!(i < str_array_length1)) {
#line 1268 "glib-2.0.vapi"
					break;
#line 575 "AccessControlLists.c"
				}
#line 1269 "glib-2.0.vapi"
				_tmp26_ = ptr;
#line 1269 "glib-2.0.vapi"
				_tmp27_ = g_stpcpy (_tmp26_, (const gchar*) separator);
#line 1269 "glib-2.0.vapi"
				ptr = _tmp27_;
#line 1270 "glib-2.0.vapi"
				_tmp29_ = str_array[i];
#line 1270 "glib-2.0.vapi"
				if (_tmp29_ != NULL) {
#line 587 "AccessControlLists.c"
					const gchar* _tmp30_;
#line 1270 "glib-2.0.vapi"
					_tmp30_ = str_array[i];
#line 1270 "glib-2.0.vapi"
					_tmp28_ = (const gchar*) _tmp30_;
#line 593 "AccessControlLists.c"
				} else {
#line 1270 "glib-2.0.vapi"
					_tmp28_ = "";
#line 597 "AccessControlLists.c"
				}
#line 1270 "glib-2.0.vapi"
				_tmp31_ = ptr;
#line 1270 "glib-2.0.vapi"
				_tmp32_ = g_stpcpy (_tmp31_, _tmp28_);
#line 1270 "glib-2.0.vapi"
				ptr = _tmp32_;
#line 605 "AccessControlLists.c"
			}
		}
#line 1273 "glib-2.0.vapi"
		_tmp33_ = res;
#line 1273 "glib-2.0.vapi"
		res = NULL;
#line 1273 "glib-2.0.vapi"
		result = (gchar*) _tmp33_;
#line 1273 "glib-2.0.vapi"
		return result;
#line 616 "AccessControlLists.c"
	} else {
		gchar* _tmp34_;
#line 1275 "glib-2.0.vapi"
		_tmp34_ = g_strdup ("");
#line 1275 "glib-2.0.vapi"
		result = _tmp34_;
#line 1275 "glib-2.0.vapi"
		return result;
#line 625 "AccessControlLists.c"
	}
}

static gchar*
pc_access_control_lists_process_desktop_entry (const gchar* path,
                                               const gchar* target,
                                               const gchar* username,
                                               gboolean admin)
{
	GKeyFile* keyfile = NULL;
	GKeyFile* _tmp0_;
	gchar** args = NULL;
	gint args_length1 = 0;
	gint _args_size_ = 0;
	gchar* exec = NULL;
	GKeyFile* _tmp6_;
	GDesktopAppInfo* _tmp7_;
	GDesktopAppInfo* _tmp8_;
	gchar** _tmp9_ = NULL;
	gint _tmp10_ = 0;
	gchar* _tmp11_;
	gchar* _tmp12_;
	GKeyFile* _tmp26_;
	gchar* _tmp27_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 62 "../src/daemon/AccessControlLists.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 62 "../src/daemon/AccessControlLists.vala"
	g_return_val_if_fail (target != NULL, NULL);
#line 62 "../src/daemon/AccessControlLists.vala"
	g_return_val_if_fail (username != NULL, NULL);
#line 63 "../src/daemon/AccessControlLists.vala"
	_tmp0_ = g_key_file_new ();
#line 63 "../src/daemon/AccessControlLists.vala"
	keyfile = _tmp0_;
#line 662 "AccessControlLists.c"
	{
		GKeyFile* _tmp1_;
#line 65 "../src/daemon/AccessControlLists.vala"
		_tmp1_ = keyfile;
#line 65 "../src/daemon/AccessControlLists.vala"
		g_key_file_load_from_file (_tmp1_, path, G_KEY_FILE_KEEP_COMMENTS | G_KEY_FILE_KEEP_TRANSLATIONS, &_inner_error0_);
#line 65 "../src/daemon/AccessControlLists.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 65 "../src/daemon/AccessControlLists.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 673 "AccessControlLists.c"
				goto __catch0_g_key_file_error;
			}
#line 65 "../src/daemon/AccessControlLists.vala"
			if (_inner_error0_->domain == G_FILE_ERROR) {
#line 678 "AccessControlLists.c"
				goto __catch0_g_file_error;
			}
#line 65 "../src/daemon/AccessControlLists.vala"
			_g_key_file_unref0 (keyfile);
#line 65 "../src/daemon/AccessControlLists.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 65 "../src/daemon/AccessControlLists.vala"
			g_clear_error (&_inner_error0_);
#line 65 "../src/daemon/AccessControlLists.vala"
			return NULL;
#line 689 "AccessControlLists.c"
		}
	}
	goto __finally0;
	__catch0_g_key_file_error:
	{
		GError* e = NULL;
		GError* _tmp2_;
		const gchar* _tmp3_;
#line 64 "../src/daemon/AccessControlLists.vala"
		e = _inner_error0_;
#line 64 "../src/daemon/AccessControlLists.vala"
		_inner_error0_ = NULL;
#line 67 "../src/daemon/AccessControlLists.vala"
		_tmp2_ = e;
#line 67 "../src/daemon/AccessControlLists.vala"
		_tmp3_ = _tmp2_->message;
#line 67 "../src/daemon/AccessControlLists.vala"
		g_warning ("AccessControlLists.vala:67: %s", _tmp3_);
#line 68 "../src/daemon/AccessControlLists.vala"
		result = NULL;
#line 68 "../src/daemon/AccessControlLists.vala"
		_g_error_free0 (e);
#line 68 "../src/daemon/AccessControlLists.vala"
		_g_key_file_unref0 (keyfile);
#line 68 "../src/daemon/AccessControlLists.vala"
		return result;
#line 716 "AccessControlLists.c"
	}
	goto __finally0;
	__catch0_g_file_error:
	{
		GError* e = NULL;
		GError* _tmp4_;
		const gchar* _tmp5_;
#line 64 "../src/daemon/AccessControlLists.vala"
		e = _inner_error0_;
#line 64 "../src/daemon/AccessControlLists.vala"
		_inner_error0_ = NULL;
#line 70 "../src/daemon/AccessControlLists.vala"
		_tmp4_ = e;
#line 70 "../src/daemon/AccessControlLists.vala"
		_tmp5_ = _tmp4_->message;
#line 70 "../src/daemon/AccessControlLists.vala"
		g_warning ("AccessControlLists.vala:70: %s", _tmp5_);
#line 71 "../src/daemon/AccessControlLists.vala"
		result = NULL;
#line 71 "../src/daemon/AccessControlLists.vala"
		_g_error_free0 (e);
#line 71 "../src/daemon/AccessControlLists.vala"
		_g_key_file_unref0 (keyfile);
#line 71 "../src/daemon/AccessControlLists.vala"
		return result;
#line 742 "AccessControlLists.c"
	}
	__finally0:
#line 64 "../src/daemon/AccessControlLists.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 64 "../src/daemon/AccessControlLists.vala"
		_g_key_file_unref0 (keyfile);
#line 64 "../src/daemon/AccessControlLists.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 64 "../src/daemon/AccessControlLists.vala"
		g_clear_error (&_inner_error0_);
#line 64 "../src/daemon/AccessControlLists.vala"
		return NULL;
#line 755 "AccessControlLists.c"
	}
#line 75 "../src/daemon/AccessControlLists.vala"
	_tmp6_ = keyfile;
#line 75 "../src/daemon/AccessControlLists.vala"
	_tmp7_ = g_desktop_app_info_new_from_keyfile (_tmp6_);
#line 75 "../src/daemon/AccessControlLists.vala"
	_tmp8_ = _tmp7_;
#line 75 "../src/daemon/AccessControlLists.vala"
	_tmp11_ = pc_utils_info_to_exec_path ((GAppInfo*) _tmp8_, &_tmp9_, &_tmp10_);
#line 75 "../src/daemon/AccessControlLists.vala"
	args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
#line 75 "../src/daemon/AccessControlLists.vala"
	args = _tmp9_;
#line 75 "../src/daemon/AccessControlLists.vala"
	args_length1 = _tmp10_;
#line 75 "../src/daemon/AccessControlLists.vala"
	_args_size_ = args_length1;
#line 75 "../src/daemon/AccessControlLists.vala"
	_tmp12_ = _tmp11_;
#line 75 "../src/daemon/AccessControlLists.vala"
	_g_object_unref0 (_tmp8_);
#line 75 "../src/daemon/AccessControlLists.vala"
	exec = _tmp12_;
#line 77 "../src/daemon/AccessControlLists.vala"
	if (admin) {
#line 781 "AccessControlLists.c"
		gchar** _tmp13_;
		gint _tmp13__length1;
		const gchar* _tmp14_;
		gchar* _tmp15_;
		GKeyFile* _tmp16_;
		gchar** _tmp17_;
		gint _tmp17__length1;
		gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
#line 78 "../src/daemon/AccessControlLists.vala"
		_tmp13_ = args;
#line 78 "../src/daemon/AccessControlLists.vala"
		_tmp13__length1 = args_length1;
#line 78 "../src/daemon/AccessControlLists.vala"
		_tmp14_ = exec;
#line 78 "../src/daemon/AccessControlLists.vala"
		_tmp15_ = g_strdup (_tmp14_);
#line 78 "../src/daemon/AccessControlLists.vala"
		_g_free0 (_tmp13_[0]);
#line 78 "../src/daemon/AccessControlLists.vala"
		_tmp13_[0] = _tmp15_;
#line 79 "../src/daemon/AccessControlLists.vala"
		_tmp16_ = keyfile;
#line 79 "../src/daemon/AccessControlLists.vala"
		_tmp17_ = args;
#line 79 "../src/daemon/AccessControlLists.vala"
		_tmp17__length1 = args_length1;
#line 79 "../src/daemon/AccessControlLists.vala"
		_tmp18_ = _vala_g_strjoinv (" ", _tmp17_, (gint) _tmp17__length1);
#line 79 "../src/daemon/AccessControlLists.vala"
		_tmp19_ = _tmp18_;
#line 79 "../src/daemon/AccessControlLists.vala"
		_tmp20_ = g_strdup_printf ("%s -a \"%s:%s:%s\"", PC_CONSTANTS_CLIENT_PATH, username, PC_CONSTANTS_PARENTAL_CONTROLS_ACTION_ID, _tmp19_);
#line 79 "../src/daemon/AccessControlLists.vala"
		_tmp21_ = _tmp20_;
#line 79 "../src/daemon/AccessControlLists.vala"
		g_key_file_set_string (_tmp16_, G_KEY_FILE_DESKTOP_GROUP, G_KEY_FILE_DESKTOP_KEY_EXEC, _tmp21_);
#line 79 "../src/daemon/AccessControlLists.vala"
		_g_free0 (_tmp21_);
#line 79 "../src/daemon/AccessControlLists.vala"
		_g_free0 (_tmp19_);
#line 825 "AccessControlLists.c"
	} else {
		GKeyFile* _tmp22_;
		const gchar* _tmp23_;
		gchar* _tmp24_;
		gchar* _tmp25_;
#line 88 "../src/daemon/AccessControlLists.vala"
		_tmp22_ = keyfile;
#line 88 "../src/daemon/AccessControlLists.vala"
		_tmp23_ = exec;
#line 88 "../src/daemon/AccessControlLists.vala"
		_tmp24_ = g_strdup_printf ("%s -d %s", PC_CONSTANTS_CLIENT_PATH, _tmp23_);
#line 88 "../src/daemon/AccessControlLists.vala"
		_tmp25_ = _tmp24_;
#line 88 "../src/daemon/AccessControlLists.vala"
		g_key_file_set_string (_tmp22_, G_KEY_FILE_DESKTOP_GROUP, G_KEY_FILE_DESKTOP_KEY_EXEC, _tmp25_);
#line 88 "../src/daemon/AccessControlLists.vala"
		_g_free0 (_tmp25_);
#line 843 "AccessControlLists.c"
	}
#line 92 "../src/daemon/AccessControlLists.vala"
	_tmp26_ = keyfile;
#line 92 "../src/daemon/AccessControlLists.vala"
	_tmp27_ = g_key_file_to_data (_tmp26_, NULL, NULL);
#line 92 "../src/daemon/AccessControlLists.vala"
	result = _tmp27_;
#line 92 "../src/daemon/AccessControlLists.vala"
	_g_free0 (exec);
#line 92 "../src/daemon/AccessControlLists.vala"
	args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
#line 92 "../src/daemon/AccessControlLists.vala"
	_g_key_file_unref0 (keyfile);
#line 92 "../src/daemon/AccessControlLists.vala"
	return result;
#line 859 "AccessControlLists.c"
}

gboolean
pc_access_control_lists_get_supported (void)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean _tmp2_;
	gboolean result;
#line 96 "../src/daemon/AccessControlLists.vala"
	_tmp0_ = g_find_program_in_path ("setfacl");
#line 96 "../src/daemon/AccessControlLists.vala"
	_tmp1_ = _tmp0_;
#line 96 "../src/daemon/AccessControlLists.vala"
	_tmp2_ = _tmp1_ != NULL;
#line 96 "../src/daemon/AccessControlLists.vala"
	_g_free0 (_tmp1_);
#line 96 "../src/daemon/AccessControlLists.vala"
	result = _tmp2_;
#line 96 "../src/daemon/AccessControlLists.vala"
	return result;
#line 881 "AccessControlLists.c"
}

void
pc_access_control_lists_setfacl (const gchar* username,
                                 const gchar* target,
                                 const gchar* permissions_str)
{
	gchar* r = NULL;
	gchar* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 99 "../src/daemon/AccessControlLists.vala"
	g_return_if_fail (username != NULL);
#line 99 "../src/daemon/AccessControlLists.vala"
	g_return_if_fail (target != NULL);
#line 99 "../src/daemon/AccessControlLists.vala"
	g_return_if_fail (permissions_str != NULL);
#line 100 "../src/daemon/AccessControlLists.vala"
	_tmp0_ = g_strdup_printf ("u:%s:%s", username, permissions_str);
#line 100 "../src/daemon/AccessControlLists.vala"
	r = _tmp0_;
#line 902 "AccessControlLists.c"
	{
		gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar** _tmp5_;
		gchar** _tmp6_;
		gint _tmp6__length1;
#line 102 "../src/daemon/AccessControlLists.vala"
		_tmp1_ = g_strdup ("setfacl");
#line 102 "../src/daemon/AccessControlLists.vala"
		_tmp2_ = g_strdup ("-m");
#line 102 "../src/daemon/AccessControlLists.vala"
		_tmp3_ = g_strdup (r);
#line 102 "../src/daemon/AccessControlLists.vala"
		_tmp4_ = g_strdup (target);
#line 102 "../src/daemon/AccessControlLists.vala"
		_tmp5_ = g_new0 (gchar*, 4 + 1);
#line 102 "../src/daemon/AccessControlLists.vala"
		_tmp5_[0] = _tmp1_;
#line 102 "../src/daemon/AccessControlLists.vala"
		_tmp5_[1] = _tmp2_;
#line 102 "../src/daemon/AccessControlLists.vala"
		_tmp5_[2] = _tmp3_;
#line 102 "../src/daemon/AccessControlLists.vala"
		_tmp5_[3] = _tmp4_;
#line 102 "../src/daemon/AccessControlLists.vala"
		_tmp6_ = _tmp5_;
#line 102 "../src/daemon/AccessControlLists.vala"
		_tmp6__length1 = 4;
#line 102 "../src/daemon/AccessControlLists.vala"
		g_spawn_async (NULL, _tmp6_, NULL, G_SPAWN_SEARCH_PATH | G_SPAWN_DO_NOT_REAP_CHILD, NULL, NULL, NULL, &_inner_error0_);
#line 102 "../src/daemon/AccessControlLists.vala"
		_tmp6_ = (_vala_array_free (_tmp6_, _tmp6__length1, (GDestroyNotify) g_free), NULL);
#line 102 "../src/daemon/AccessControlLists.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 102 "../src/daemon/AccessControlLists.vala"
			if (_inner_error0_->domain == G_SPAWN_ERROR) {
#line 941 "AccessControlLists.c"
				goto __catch0_g_spawn_error;
			}
#line 102 "../src/daemon/AccessControlLists.vala"
			_g_free0 (r);
#line 102 "../src/daemon/AccessControlLists.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 102 "../src/daemon/AccessControlLists.vala"
			g_clear_error (&_inner_error0_);
#line 102 "../src/daemon/AccessControlLists.vala"
			return;
#line 952 "AccessControlLists.c"
		}
	}
	goto __finally0;
	__catch0_g_spawn_error:
	{
		GError* e = NULL;
		GError* _tmp7_;
		const gchar* _tmp8_;
#line 101 "../src/daemon/AccessControlLists.vala"
		e = _inner_error0_;
#line 101 "../src/daemon/AccessControlLists.vala"
		_inner_error0_ = NULL;
#line 109 "../src/daemon/AccessControlLists.vala"
		_tmp7_ = e;
#line 109 "../src/daemon/AccessControlLists.vala"
		_tmp8_ = _tmp7_->message;
#line 109 "../src/daemon/AccessControlLists.vala"
		g_warning ("AccessControlLists.vala:109: %s", _tmp8_);
#line 101 "../src/daemon/AccessControlLists.vala"
		_g_error_free0 (e);
#line 973 "AccessControlLists.c"
	}
	__finally0:
#line 101 "../src/daemon/AccessControlLists.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 101 "../src/daemon/AccessControlLists.vala"
		_g_free0 (r);
#line 101 "../src/daemon/AccessControlLists.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 101 "../src/daemon/AccessControlLists.vala"
		g_clear_error (&_inner_error0_);
#line 101 "../src/daemon/AccessControlLists.vala"
		return;
#line 986 "AccessControlLists.c"
	}
#line 99 "../src/daemon/AccessControlLists.vala"
	_g_free0 (r);
#line 990 "AccessControlLists.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 139 "../src/daemon/AccessControlLists.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 998 "AccessControlLists.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 139 "../src/daemon/AccessControlLists.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 1006 "AccessControlLists.c"
}

static guint8*
string_get_data (const gchar* self,
                 gint* result_length1)
{
	guint8* result;
	guint8* res = NULL;
	gint res_length1;
	gint _res_size_;
	gint _tmp0_;
	gint _tmp1_;
	guint8* _tmp2_;
	gint _tmp2__length1;
#line 1609 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1610 "glib-2.0.vapi"
	res = (guint8*) self;
#line 1610 "glib-2.0.vapi"
	res_length1 = -1;
#line 1610 "glib-2.0.vapi"
	_res_size_ = res_length1;
#line 1611 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1611 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1611 "glib-2.0.vapi"
	res_length1 = (gint) _tmp1_;
#line 1612 "glib-2.0.vapi"
	_tmp2_ = res;
#line 1612 "glib-2.0.vapi"
	_tmp2__length1 = res_length1;
#line 1612 "glib-2.0.vapi"
	if (result_length1) {
#line 1612 "glib-2.0.vapi"
		*result_length1 = _tmp2__length1;
#line 1043 "AccessControlLists.c"
	}
#line 1612 "glib-2.0.vapi"
	result = _tmp2_;
#line 1612 "glib-2.0.vapi"
	return result;
#line 1049 "AccessControlLists.c"
}

static void
pc_access_control_lists_apply_permissions (const gchar* username,
                                           gchar** targets,
                                           gint targets_length1,
                                           const gchar* permissions_str,
                                           gboolean admin)
{
	GList* infos = NULL;
	GList* _tmp2_;
	GError* _inner_error0_ = NULL;
#line 113 "../src/daemon/AccessControlLists.vala"
	g_return_if_fail (username != NULL);
#line 113 "../src/daemon/AccessControlLists.vala"
	g_return_if_fail (permissions_str != NULL);
#line 1066 "AccessControlLists.c"
	{
		gchar** target_collection = NULL;
		gint target_collection_length1 = 0;
		gint _target_collection_size_ = 0;
		gint target_it = 0;
#line 114 "../src/daemon/AccessControlLists.vala"
		target_collection = targets;
#line 114 "../src/daemon/AccessControlLists.vala"
		target_collection_length1 = targets_length1;
#line 114 "../src/daemon/AccessControlLists.vala"
		for (target_it = 0; target_it < target_collection_length1; target_it = target_it + 1) {
#line 1078 "AccessControlLists.c"
			gchar* _tmp0_;
			gchar* target = NULL;
#line 114 "../src/daemon/AccessControlLists.vala"
			_tmp0_ = g_strdup (target_collection[target_it]);
#line 114 "../src/daemon/AccessControlLists.vala"
			target = _tmp0_;
#line 1085 "AccessControlLists.c"
			{
				const gchar* _tmp1_;
#line 115 "../src/daemon/AccessControlLists.vala"
				_tmp1_ = target;
#line 115 "../src/daemon/AccessControlLists.vala"
				pc_access_control_lists_setfacl (username, _tmp1_, permissions_str);
#line 114 "../src/daemon/AccessControlLists.vala"
				_g_free0 (target);
#line 1094 "AccessControlLists.c"
			}
		}
	}
#line 118 "../src/daemon/AccessControlLists.vala"
	_tmp2_ = g_app_info_get_all ();
#line 118 "../src/daemon/AccessControlLists.vala"
	infos = _tmp2_;
#line 1102 "AccessControlLists.c"
	{
		gchar** target_collection = NULL;
		gint target_collection_length1 = 0;
		gint _target_collection_size_ = 0;
		gint target_it = 0;
#line 119 "../src/daemon/AccessControlLists.vala"
		target_collection = targets;
#line 119 "../src/daemon/AccessControlLists.vala"
		target_collection_length1 = targets_length1;
#line 119 "../src/daemon/AccessControlLists.vala"
		for (target_it = 0; target_it < target_collection_length1; target_it = target_it + 1) {
#line 1114 "AccessControlLists.c"
			gchar* _tmp3_;
			gchar* target = NULL;
#line 119 "../src/daemon/AccessControlLists.vala"
			_tmp3_ = g_strdup (target_collection[target_it]);
#line 119 "../src/daemon/AccessControlLists.vala"
			target = _tmp3_;
#line 1121 "AccessControlLists.c"
			{
				GAppInfo* match = NULL;
				const gchar* _tmp4_;
				GList* _tmp5_;
				GAppInfo* _tmp6_;
				gboolean _tmp7_ = FALSE;
				GAppInfo* _tmp8_;
				const gchar* target_filename = NULL;
				GAppInfo* _tmp10_;
				const gchar* _tmp11_;
				const gchar* _tmp12_;
				GFile* appdir_file = NULL;
				GFile* _tmp13_;
				GFile* target_file = NULL;
				const gchar* _tmp14_;
				GFile* _tmp15_;
				gboolean _tmp16_ = FALSE;
				GFile* _tmp17_;
				GFile* dest = NULL;
				GFile* _tmp19_;
				GFile* _tmp20_;
				gchar* _tmp21_;
				gchar* _tmp22_;
				GFile* _tmp23_;
				GFile* _tmp24_;
				GFile* _tmp25_;
				gchar* contents = NULL;
				GFile* _tmp29_;
				gchar* _tmp30_;
				gchar* _tmp31_;
				const gchar* _tmp32_;
				gchar* _tmp33_;
				gchar* _tmp34_;
				const gchar* _tmp35_;
#line 120 "../src/daemon/AccessControlLists.vala"
				_tmp4_ = target;
#line 120 "../src/daemon/AccessControlLists.vala"
				_tmp5_ = infos;
#line 120 "../src/daemon/AccessControlLists.vala"
				_tmp6_ = pc_access_control_lists_get_match (_tmp4_, _tmp5_);
#line 120 "../src/daemon/AccessControlLists.vala"
				match = _tmp6_;
#line 121 "../src/daemon/AccessControlLists.vala"
				_tmp8_ = match;
#line 121 "../src/daemon/AccessControlLists.vala"
				if (_tmp8_ == NULL) {
#line 121 "../src/daemon/AccessControlLists.vala"
					_tmp7_ = TRUE;
#line 1170 "AccessControlLists.c"
				} else {
					GAppInfo* _tmp9_;
#line 121 "../src/daemon/AccessControlLists.vala"
					_tmp9_ = match;
#line 121 "../src/daemon/AccessControlLists.vala"
					_tmp7_ = !G_TYPE_CHECK_INSTANCE_TYPE (_tmp9_, G_TYPE_DESKTOP_APP_INFO);
#line 1177 "AccessControlLists.c"
				}
#line 121 "../src/daemon/AccessControlLists.vala"
				if (_tmp7_) {
#line 122 "../src/daemon/AccessControlLists.vala"
					_g_object_unref0 (match);
#line 122 "../src/daemon/AccessControlLists.vala"
					_g_free0 (target);
#line 122 "../src/daemon/AccessControlLists.vala"
					continue;
#line 1187 "AccessControlLists.c"
				}
#line 125 "../src/daemon/AccessControlLists.vala"
				_tmp10_ = match;
#line 125 "../src/daemon/AccessControlLists.vala"
				_tmp11_ = g_desktop_app_info_get_filename (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, G_TYPE_DESKTOP_APP_INFO, GDesktopAppInfo));
#line 125 "../src/daemon/AccessControlLists.vala"
				target_filename = _tmp11_;
#line 126 "../src/daemon/AccessControlLists.vala"
				_tmp12_ = target_filename;
#line 126 "../src/daemon/AccessControlLists.vala"
				if (_tmp12_ == NULL) {
#line 127 "../src/daemon/AccessControlLists.vala"
					_g_object_unref0 (match);
#line 127 "../src/daemon/AccessControlLists.vala"
					_g_free0 (target);
#line 127 "../src/daemon/AccessControlLists.vala"
					continue;
#line 1205 "AccessControlLists.c"
				}
#line 130 "../src/daemon/AccessControlLists.vala"
				_tmp13_ = pc_access_control_lists_create_desktop_files_dir (username);
#line 130 "../src/daemon/AccessControlLists.vala"
				appdir_file = _tmp13_;
#line 131 "../src/daemon/AccessControlLists.vala"
				_tmp14_ = target_filename;
#line 131 "../src/daemon/AccessControlLists.vala"
				_tmp15_ = g_file_new_for_path (_tmp14_);
#line 131 "../src/daemon/AccessControlLists.vala"
				target_file = _tmp15_;
#line 132 "../src/daemon/AccessControlLists.vala"
				_tmp17_ = target_file;
#line 132 "../src/daemon/AccessControlLists.vala"
				if (!g_file_query_exists (_tmp17_, NULL)) {
#line 132 "../src/daemon/AccessControlLists.vala"
					_tmp16_ = TRUE;
#line 1223 "AccessControlLists.c"
				} else {
					GFile* _tmp18_;
#line 132 "../src/daemon/AccessControlLists.vala"
					_tmp18_ = appdir_file;
#line 132 "../src/daemon/AccessControlLists.vala"
					_tmp16_ = _tmp18_ == NULL;
#line 1230 "AccessControlLists.c"
				}
#line 132 "../src/daemon/AccessControlLists.vala"
				if (_tmp16_) {
#line 133 "../src/daemon/AccessControlLists.vala"
					_g_object_unref0 (target_file);
#line 133 "../src/daemon/AccessControlLists.vala"
					_g_object_unref0 (appdir_file);
#line 133 "../src/daemon/AccessControlLists.vala"
					_g_object_unref0 (match);
#line 133 "../src/daemon/AccessControlLists.vala"
					_g_free0 (target);
#line 133 "../src/daemon/AccessControlLists.vala"
					continue;
#line 1244 "AccessControlLists.c"
				}
#line 136 "../src/daemon/AccessControlLists.vala"
				_tmp19_ = appdir_file;
#line 136 "../src/daemon/AccessControlLists.vala"
				_tmp20_ = target_file;
#line 136 "../src/daemon/AccessControlLists.vala"
				_tmp21_ = g_file_get_basename (_tmp20_);
#line 136 "../src/daemon/AccessControlLists.vala"
				_tmp22_ = _tmp21_;
#line 136 "../src/daemon/AccessControlLists.vala"
				_tmp23_ = g_file_get_child (_tmp19_, _tmp22_);
#line 136 "../src/daemon/AccessControlLists.vala"
				_tmp24_ = _tmp23_;
#line 136 "../src/daemon/AccessControlLists.vala"
				_g_free0 (_tmp22_);
#line 136 "../src/daemon/AccessControlLists.vala"
				dest = _tmp24_;
#line 137 "../src/daemon/AccessControlLists.vala"
				_tmp25_ = dest;
#line 137 "../src/daemon/AccessControlLists.vala"
				if (g_file_query_exists (_tmp25_, NULL)) {
#line 138 "../src/daemon/AccessControlLists.vala"
					if (g_strcmp0 (permissions_str, PC_ACCESS_CONTROL_LISTS_DEFAULT_PERMISSIONS) == 0) {
#line 1268 "AccessControlLists.c"
						{
							GFile* _tmp26_;
#line 140 "../src/daemon/AccessControlLists.vala"
							_tmp26_ = dest;
#line 140 "../src/daemon/AccessControlLists.vala"
							g_file_delete (_tmp26_, NULL, &_inner_error0_);
#line 140 "../src/daemon/AccessControlLists.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1277 "AccessControlLists.c"
								goto __catch0_g_error;
							}
						}
						goto __finally0;
						__catch0_g_error:
						{
							GError* e = NULL;
							GError* _tmp27_;
							const gchar* _tmp28_;
#line 139 "../src/daemon/AccessControlLists.vala"
							e = _inner_error0_;
#line 139 "../src/daemon/AccessControlLists.vala"
							_inner_error0_ = NULL;
#line 142 "../src/daemon/AccessControlLists.vala"
							_tmp27_ = e;
#line 142 "../src/daemon/AccessControlLists.vala"
							_tmp28_ = _tmp27_->message;
#line 142 "../src/daemon/AccessControlLists.vala"
							g_warning ("AccessControlLists.vala:142: %s", _tmp28_);
#line 139 "../src/daemon/AccessControlLists.vala"
							_g_error_free0 (e);
#line 1299 "AccessControlLists.c"
						}
						__finally0:
#line 139 "../src/daemon/AccessControlLists.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 139 "../src/daemon/AccessControlLists.vala"
							_g_object_unref0 (dest);
#line 139 "../src/daemon/AccessControlLists.vala"
							_g_object_unref0 (target_file);
#line 139 "../src/daemon/AccessControlLists.vala"
							_g_object_unref0 (appdir_file);
#line 139 "../src/daemon/AccessControlLists.vala"
							_g_object_unref0 (match);
#line 139 "../src/daemon/AccessControlLists.vala"
							_g_free0 (target);
#line 139 "../src/daemon/AccessControlLists.vala"
							(infos == NULL) ? NULL : (infos = (_g_list_free__g_object_unref0_ (infos), NULL));
#line 139 "../src/daemon/AccessControlLists.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 139 "../src/daemon/AccessControlLists.vala"
							g_clear_error (&_inner_error0_);
#line 139 "../src/daemon/AccessControlLists.vala"
							return;
#line 1322 "AccessControlLists.c"
						}
#line 145 "../src/daemon/AccessControlLists.vala"
						_g_object_unref0 (dest);
#line 145 "../src/daemon/AccessControlLists.vala"
						_g_object_unref0 (target_file);
#line 145 "../src/daemon/AccessControlLists.vala"
						_g_object_unref0 (appdir_file);
#line 145 "../src/daemon/AccessControlLists.vala"
						_g_object_unref0 (match);
#line 145 "../src/daemon/AccessControlLists.vala"
						_g_free0 (target);
#line 145 "../src/daemon/AccessControlLists.vala"
						continue;
#line 1336 "AccessControlLists.c"
					}
				}
#line 149 "../src/daemon/AccessControlLists.vala"
				_tmp29_ = target_file;
#line 149 "../src/daemon/AccessControlLists.vala"
				_tmp30_ = g_file_get_path (_tmp29_);
#line 149 "../src/daemon/AccessControlLists.vala"
				_tmp31_ = _tmp30_;
#line 149 "../src/daemon/AccessControlLists.vala"
				_tmp32_ = target;
#line 149 "../src/daemon/AccessControlLists.vala"
				_tmp33_ = pc_access_control_lists_process_desktop_entry (_tmp31_, _tmp32_, username, admin);
#line 149 "../src/daemon/AccessControlLists.vala"
				_tmp34_ = _tmp33_;
#line 149 "../src/daemon/AccessControlLists.vala"
				_g_free0 (_tmp31_);
#line 149 "../src/daemon/AccessControlLists.vala"
				contents = _tmp34_;
#line 150 "../src/daemon/AccessControlLists.vala"
				_tmp35_ = contents;
#line 150 "../src/daemon/AccessControlLists.vala"
				if (_tmp35_ == NULL) {
#line 151 "../src/daemon/AccessControlLists.vala"
					_g_free0 (contents);
#line 151 "../src/daemon/AccessControlLists.vala"
					_g_object_unref0 (dest);
#line 151 "../src/daemon/AccessControlLists.vala"
					_g_object_unref0 (target_file);
#line 151 "../src/daemon/AccessControlLists.vala"
					_g_object_unref0 (appdir_file);
#line 151 "../src/daemon/AccessControlLists.vala"
					_g_object_unref0 (match);
#line 151 "../src/daemon/AccessControlLists.vala"
					_g_free0 (target);
#line 151 "../src/daemon/AccessControlLists.vala"
					continue;
#line 1373 "AccessControlLists.c"
				}
				{
					GFileOutputStream* os = NULL;
					GFile* _tmp36_;
					GFileOutputStream* _tmp37_;
					GFileOutputStream* _tmp38_;
					const gchar* _tmp39_;
					guint8* _tmp40_;
					gint _tmp40__length1;
					gint _tmp41_ = 0;
					guint8* _tmp42_;
					gint _tmp42__length1;
					GFileOutputStream* _tmp43_;
#line 155 "../src/daemon/AccessControlLists.vala"
					_tmp36_ = dest;
#line 155 "../src/daemon/AccessControlLists.vala"
					_tmp37_ = g_file_create (_tmp36_, G_FILE_CREATE_REPLACE_DESTINATION, NULL, &_inner_error0_);
#line 155 "../src/daemon/AccessControlLists.vala"
					os = _tmp37_;
#line 155 "../src/daemon/AccessControlLists.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1395 "AccessControlLists.c"
						goto __catch1_g_error;
					}
#line 156 "../src/daemon/AccessControlLists.vala"
					_tmp38_ = os;
#line 156 "../src/daemon/AccessControlLists.vala"
					_tmp39_ = contents;
#line 156 "../src/daemon/AccessControlLists.vala"
					_tmp40_ = string_get_data (_tmp39_, &_tmp41_);
#line 156 "../src/daemon/AccessControlLists.vala"
					_tmp40__length1 = _tmp41_;
#line 156 "../src/daemon/AccessControlLists.vala"
					_tmp42_ = _tmp40_;
#line 156 "../src/daemon/AccessControlLists.vala"
					_tmp42__length1 = _tmp40__length1;
#line 156 "../src/daemon/AccessControlLists.vala"
					g_output_stream_write_all ((GOutputStream*) _tmp38_, _tmp42_, (gsize) _tmp42__length1, NULL, NULL, &_inner_error0_);
#line 156 "../src/daemon/AccessControlLists.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 156 "../src/daemon/AccessControlLists.vala"
						_g_object_unref0 (os);
#line 1416 "AccessControlLists.c"
						goto __catch1_g_error;
					}
#line 157 "../src/daemon/AccessControlLists.vala"
					_tmp43_ = os;
#line 157 "../src/daemon/AccessControlLists.vala"
					g_output_stream_close ((GOutputStream*) _tmp43_, NULL, &_inner_error0_);
#line 157 "../src/daemon/AccessControlLists.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 157 "../src/daemon/AccessControlLists.vala"
						_g_object_unref0 (os);
#line 1427 "AccessControlLists.c"
						goto __catch1_g_error;
					}
#line 154 "../src/daemon/AccessControlLists.vala"
					_g_object_unref0 (os);
#line 1432 "AccessControlLists.c"
				}
				goto __finally1;
				__catch1_g_error:
				{
					GError* e = NULL;
					GError* _tmp44_;
					const gchar* _tmp45_;
#line 154 "../src/daemon/AccessControlLists.vala"
					e = _inner_error0_;
#line 154 "../src/daemon/AccessControlLists.vala"
					_inner_error0_ = NULL;
#line 159 "../src/daemon/AccessControlLists.vala"
					_tmp44_ = e;
#line 159 "../src/daemon/AccessControlLists.vala"
					_tmp45_ = _tmp44_->message;
#line 159 "../src/daemon/AccessControlLists.vala"
					g_warning ("AccessControlLists.vala:159: %s", _tmp45_);
#line 154 "../src/daemon/AccessControlLists.vala"
					_g_error_free0 (e);
#line 1452 "AccessControlLists.c"
				}
				__finally1:
#line 154 "../src/daemon/AccessControlLists.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 154 "../src/daemon/AccessControlLists.vala"
					_g_free0 (contents);
#line 154 "../src/daemon/AccessControlLists.vala"
					_g_object_unref0 (dest);
#line 154 "../src/daemon/AccessControlLists.vala"
					_g_object_unref0 (target_file);
#line 154 "../src/daemon/AccessControlLists.vala"
					_g_object_unref0 (appdir_file);
#line 154 "../src/daemon/AccessControlLists.vala"
					_g_object_unref0 (match);
#line 154 "../src/daemon/AccessControlLists.vala"
					_g_free0 (target);
#line 154 "../src/daemon/AccessControlLists.vala"
					(infos == NULL) ? NULL : (infos = (_g_list_free__g_object_unref0_ (infos), NULL));
#line 154 "../src/daemon/AccessControlLists.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 154 "../src/daemon/AccessControlLists.vala"
					g_clear_error (&_inner_error0_);
#line 154 "../src/daemon/AccessControlLists.vala"
					return;
#line 1477 "AccessControlLists.c"
				}
#line 119 "../src/daemon/AccessControlLists.vala"
				_g_free0 (contents);
#line 119 "../src/daemon/AccessControlLists.vala"
				_g_object_unref0 (dest);
#line 119 "../src/daemon/AccessControlLists.vala"
				_g_object_unref0 (target_file);
#line 119 "../src/daemon/AccessControlLists.vala"
				_g_object_unref0 (appdir_file);
#line 119 "../src/daemon/AccessControlLists.vala"
				_g_object_unref0 (match);
#line 119 "../src/daemon/AccessControlLists.vala"
				_g_free0 (target);
#line 1491 "AccessControlLists.c"
			}
		}
	}
#line 113 "../src/daemon/AccessControlLists.vala"
	(infos == NULL) ? NULL : (infos = (_g_list_free__g_object_unref0_ (infos), NULL));
#line 1497 "AccessControlLists.c"
}

void
pc_access_control_lists_apply_targets (const gchar* username,
                                       gchar** old_targets,
                                       gint old_targets_length1,
                                       gchar** targets,
                                       gint targets_length1,
                                       gboolean old_admin,
                                       gboolean admin)
{
#line 164 "../src/daemon/AccessControlLists.vala"
	g_return_if_fail (username != NULL);
#line 171 "../src/daemon/AccessControlLists.vala"
	pc_access_control_lists_apply_permissions (username, old_targets, (gint) old_targets_length1, PC_ACCESS_CONTROL_LISTS_DEFAULT_PERMISSIONS, old_admin);
#line 172 "../src/daemon/AccessControlLists.vala"
	pc_access_control_lists_apply_permissions (username, targets, (gint) targets_length1, PC_ACCESS_CONTROL_LISTS_NO_EXEC_PERMISSIONS, admin);
#line 1515 "AccessControlLists.c"
}

PCAccessControlLists*
pc_access_control_lists_construct (GType object_type)
{
	PCAccessControlLists* self = NULL;
#line 23 "../src/daemon/AccessControlLists.vala"
	self = (PCAccessControlLists*) g_type_create_instance (object_type);
#line 23 "../src/daemon/AccessControlLists.vala"
	return self;
#line 1526 "AccessControlLists.c"
}

PCAccessControlLists*
pc_access_control_lists_new (void)
{
#line 23 "../src/daemon/AccessControlLists.vala"
	return pc_access_control_lists_construct (PC_TYPE_ACCESS_CONTROL_LISTS);
#line 1534 "AccessControlLists.c"
}

static void
pc_value_access_control_lists_init (GValue* value)
{
#line 23 "../src/daemon/AccessControlLists.vala"
	value->data[0].v_pointer = NULL;
#line 1542 "AccessControlLists.c"
}

static void
pc_value_access_control_lists_free_value (GValue* value)
{
#line 23 "../src/daemon/AccessControlLists.vala"
	if (value->data[0].v_pointer) {
#line 23 "../src/daemon/AccessControlLists.vala"
		pc_access_control_lists_unref (value->data[0].v_pointer);
#line 1552 "AccessControlLists.c"
	}
}

static void
pc_value_access_control_lists_copy_value (const GValue* src_value,
                                          GValue* dest_value)
{
#line 23 "../src/daemon/AccessControlLists.vala"
	if (src_value->data[0].v_pointer) {
#line 23 "../src/daemon/AccessControlLists.vala"
		dest_value->data[0].v_pointer = pc_access_control_lists_ref (src_value->data[0].v_pointer);
#line 1564 "AccessControlLists.c"
	} else {
#line 23 "../src/daemon/AccessControlLists.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1568 "AccessControlLists.c"
	}
}

static gpointer
pc_value_access_control_lists_peek_pointer (const GValue* value)
{
#line 23 "../src/daemon/AccessControlLists.vala"
	return value->data[0].v_pointer;
#line 1577 "AccessControlLists.c"
}

static gchar*
pc_value_access_control_lists_collect_value (GValue* value,
                                             guint n_collect_values,
                                             GTypeCValue* collect_values,
                                             guint collect_flags)
{
#line 23 "../src/daemon/AccessControlLists.vala"
	if (collect_values[0].v_pointer) {
#line 1588 "AccessControlLists.c"
		PCAccessControlLists * object;
		object = collect_values[0].v_pointer;
#line 23 "../src/daemon/AccessControlLists.vala"
		if (object->parent_instance.g_class == NULL) {
#line 23 "../src/daemon/AccessControlLists.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1595 "AccessControlLists.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 23 "../src/daemon/AccessControlLists.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1599 "AccessControlLists.c"
		}
#line 23 "../src/daemon/AccessControlLists.vala"
		value->data[0].v_pointer = pc_access_control_lists_ref (object);
#line 1603 "AccessControlLists.c"
	} else {
#line 23 "../src/daemon/AccessControlLists.vala"
		value->data[0].v_pointer = NULL;
#line 1607 "AccessControlLists.c"
	}
#line 23 "../src/daemon/AccessControlLists.vala"
	return NULL;
#line 1611 "AccessControlLists.c"
}

static gchar*
pc_value_access_control_lists_lcopy_value (const GValue* value,
                                           guint n_collect_values,
                                           GTypeCValue* collect_values,
                                           guint collect_flags)
{
	PCAccessControlLists ** object_p;
	object_p = collect_values[0].v_pointer;
#line 23 "../src/daemon/AccessControlLists.vala"
	if (!object_p) {
#line 23 "../src/daemon/AccessControlLists.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1626 "AccessControlLists.c"
	}
#line 23 "../src/daemon/AccessControlLists.vala"
	if (!value->data[0].v_pointer) {
#line 23 "../src/daemon/AccessControlLists.vala"
		*object_p = NULL;
#line 1632 "AccessControlLists.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 23 "../src/daemon/AccessControlLists.vala"
		*object_p = value->data[0].v_pointer;
#line 1636 "AccessControlLists.c"
	} else {
#line 23 "../src/daemon/AccessControlLists.vala"
		*object_p = pc_access_control_lists_ref (value->data[0].v_pointer);
#line 1640 "AccessControlLists.c"
	}
#line 23 "../src/daemon/AccessControlLists.vala"
	return NULL;
#line 1644 "AccessControlLists.c"
}

GParamSpec*
pc_param_spec_access_control_lists (const gchar* name,
                                    const gchar* nick,
                                    const gchar* blurb,
                                    GType object_type,
                                    GParamFlags flags)
{
	PCParamSpecAccessControlLists* spec;
#line 23 "../src/daemon/AccessControlLists.vala"
	g_return_val_if_fail (g_type_is_a (object_type, PC_TYPE_ACCESS_CONTROL_LISTS), NULL);
#line 23 "../src/daemon/AccessControlLists.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 23 "../src/daemon/AccessControlLists.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 23 "../src/daemon/AccessControlLists.vala"
	return G_PARAM_SPEC (spec);
#line 1663 "AccessControlLists.c"
}

gpointer
pc_value_get_access_control_lists (const GValue* value)
{
#line 23 "../src/daemon/AccessControlLists.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PC_TYPE_ACCESS_CONTROL_LISTS), NULL);
#line 23 "../src/daemon/AccessControlLists.vala"
	return value->data[0].v_pointer;
#line 1673 "AccessControlLists.c"
}

void
pc_value_set_access_control_lists (GValue* value,
                                   gpointer v_object)
{
	PCAccessControlLists * old;
#line 23 "../src/daemon/AccessControlLists.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PC_TYPE_ACCESS_CONTROL_LISTS));
#line 23 "../src/daemon/AccessControlLists.vala"
	old = value->data[0].v_pointer;
#line 23 "../src/daemon/AccessControlLists.vala"
	if (v_object) {
#line 23 "../src/daemon/AccessControlLists.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PC_TYPE_ACCESS_CONTROL_LISTS));
#line 23 "../src/daemon/AccessControlLists.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 23 "../src/daemon/AccessControlLists.vala"
		value->data[0].v_pointer = v_object;
#line 23 "../src/daemon/AccessControlLists.vala"
		pc_access_control_lists_ref (value->data[0].v_pointer);
#line 1695 "AccessControlLists.c"
	} else {
#line 23 "../src/daemon/AccessControlLists.vala"
		value->data[0].v_pointer = NULL;
#line 1699 "AccessControlLists.c"
	}
#line 23 "../src/daemon/AccessControlLists.vala"
	if (old) {
#line 23 "../src/daemon/AccessControlLists.vala"
		pc_access_control_lists_unref (old);
#line 1705 "AccessControlLists.c"
	}
}

void
pc_value_take_access_control_lists (GValue* value,
                                    gpointer v_object)
{
	PCAccessControlLists * old;
#line 23 "../src/daemon/AccessControlLists.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PC_TYPE_ACCESS_CONTROL_LISTS));
#line 23 "../src/daemon/AccessControlLists.vala"
	old = value->data[0].v_pointer;
#line 23 "../src/daemon/AccessControlLists.vala"
	if (v_object) {
#line 23 "../src/daemon/AccessControlLists.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PC_TYPE_ACCESS_CONTROL_LISTS));
#line 23 "../src/daemon/AccessControlLists.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 23 "../src/daemon/AccessControlLists.vala"
		value->data[0].v_pointer = v_object;
#line 1726 "AccessControlLists.c"
	} else {
#line 23 "../src/daemon/AccessControlLists.vala"
		value->data[0].v_pointer = NULL;
#line 1730 "AccessControlLists.c"
	}
#line 23 "../src/daemon/AccessControlLists.vala"
	if (old) {
#line 23 "../src/daemon/AccessControlLists.vala"
		pc_access_control_lists_unref (old);
#line 1736 "AccessControlLists.c"
	}
}

static void
pc_access_control_lists_class_init (PCAccessControlListsClass * klass,
                                    gpointer klass_data)
{
#line 23 "../src/daemon/AccessControlLists.vala"
	pc_access_control_lists_parent_class = g_type_class_peek_parent (klass);
#line 23 "../src/daemon/AccessControlLists.vala"
	((PCAccessControlListsClass *) klass)->finalize = pc_access_control_lists_finalize;
#line 1748 "AccessControlLists.c"
}

static void
pc_access_control_lists_instance_init (PCAccessControlLists * self,
                                       gpointer klass)
{
#line 23 "../src/daemon/AccessControlLists.vala"
	self->ref_count = 1;
#line 1757 "AccessControlLists.c"
}

static void
pc_access_control_lists_finalize (PCAccessControlLists * obj)
{
	PCAccessControlLists * self;
#line 23 "../src/daemon/AccessControlLists.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PC_TYPE_ACCESS_CONTROL_LISTS, PCAccessControlLists);
#line 23 "../src/daemon/AccessControlLists.vala"
	g_signal_handlers_destroy (self);
#line 1768 "AccessControlLists.c"
}

static GType
pc_access_control_lists_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { pc_value_access_control_lists_init, pc_value_access_control_lists_free_value, pc_value_access_control_lists_copy_value, pc_value_access_control_lists_peek_pointer, "p", pc_value_access_control_lists_collect_value, "p", pc_value_access_control_lists_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (PCAccessControlListsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) pc_access_control_lists_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PCAccessControlLists), 0, (GInstanceInitFunc) pc_access_control_lists_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType pc_access_control_lists_type_id;
	pc_access_control_lists_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PCAccessControlLists", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return pc_access_control_lists_type_id;
}

GType
pc_access_control_lists_get_type (void)
{
	static volatile gsize pc_access_control_lists_type_id__once = 0;
	if (g_once_init_enter (&pc_access_control_lists_type_id__once)) {
		GType pc_access_control_lists_type_id;
		pc_access_control_lists_type_id = pc_access_control_lists_get_type_once ();
		g_once_init_leave (&pc_access_control_lists_type_id__once, pc_access_control_lists_type_id);
	}
	return pc_access_control_lists_type_id__once;
}

gpointer
pc_access_control_lists_ref (gpointer instance)
{
	PCAccessControlLists * self;
	self = instance;
#line 23 "../src/daemon/AccessControlLists.vala"
	g_atomic_int_inc (&self->ref_count);
#line 23 "../src/daemon/AccessControlLists.vala"
	return instance;
#line 1803 "AccessControlLists.c"
}

void
pc_access_control_lists_unref (gpointer instance)
{
	PCAccessControlLists * self;
	self = instance;
#line 23 "../src/daemon/AccessControlLists.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 23 "../src/daemon/AccessControlLists.vala"
		PC_ACCESS_CONTROL_LISTS_GET_CLASS (self)->finalize (self);
#line 23 "../src/daemon/AccessControlLists.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1817 "AccessControlLists.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

